Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcsms_my_trc.F90	(revision 5601)
@@ -25,4 +25,15 @@
    PUBLIC   trc_sms_my_trc_alloc ! called by trcini_my_trc.F90 module
 
+   INTEGER , PUBLIC :: nl_age                         ! T level surrounding age_depth
+   INTEGER , PUBLIC :: nla_age                        ! T level wholly above age_depth
+   INTEGER , PUBLIC :: nlb_age                        ! T level wholly below age_depth
+
+   REAL(wp), PUBLIC ::   rryear                    !: recip number of seconds in one year
+   REAL(wp), PUBLIC ::   age_depth = 10.           !: depth over which age tracer reset to zero
+   REAL(wp), PUBLIC ::   age_kill_rate = -1./7200. !: recip of relaxation timescale (s) for  age tracer shallower than age_depth
+   REAL(wp), PUBLIC ::   frac_kill_age             !: fraction of level nl_age above age_depth where it is relaxed towards zero
+   REAL(wp), PUBLIC ::   frac_add_age              !: fraction of level nl_age below age_depth where it is incremented
+
+
    ! Defined HERE the arrays specific to MY_TRC sms and ALLOCATE them in trc_sms_my_trc_alloc
 
@@ -44,5 +55,5 @@
       !
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
-      INTEGER ::   jn   ! dummy loop index
+      INTEGER ::   jn, jk   ! dummy loop index
       REAL(wp), POINTER, DIMENSION(:,:,:) :: ztrmyt
 !!----------------------------------------------------------------------
@@ -56,10 +67,15 @@
       IF( l_trdtrc )  CALL wrk_alloc( jpi, jpj, jpk, ztrmyt )
 
-      WHERE( (glamt <= 170) .AND. (glamt >= 160) .AND. (gphit <= -74) .AND. (gphit >=-75.6) )
-        trn(:,:,1,jpmyt1) = 1._wp
-        trb(:,:,1,jpmyt1) = 1._wp
-        tra(:,:,1,jpmyt1) = 0._wp
-      END WHERE
-
+      DO jk = 1, nla_age
+         tra(:,:,jk,jpmyt1) = age_kill_rate * trb(:,:,jk,jpmyt1)
+      ENDDO
+      !
+      tra(:,:,nl_age,jpmyt1) = frac_kill_age * age_kill_rate * trb(:,:,nl_age,jpmyt1)  &
+          &                  + frac_add_age  * rryear * tmask(:,:,nl_age)
+      !
+      DO jk = nlb_age, jpk
+         tra(:,:,jk,jpmyt1) = tmask(:,:,jk) * rryear
+      ENDDO
+      !
       IF( l_trdtrc ) THEN      ! Save the trends in the ixed layer
           DO jn = jp_myt0, jp_myt1
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcwri_my_trc.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcwri_my_trc.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/MY_TRC/trcwri_my_trc.F90	(revision 5601)
@@ -14,5 +14,6 @@
    USE trc         ! passive tracers common variables 
    USE oce_trc
-   USE crs, ONLY : ln_crs
+   USE crs, ONLY : ln_crs,ln_crs_top,ahtt_crs,ahtu_crs,ahtv_crs,ahtw_crs,jpi_crs,jpj_crs
+   USE iom, ONLY : iom_swap, iom_put
 
    IMPLICIT NONE
@@ -33,5 +34,11 @@
       INTEGER              :: jn
       !!---------------------------------------------------------------------
-      IF( ln_crs ) CALL iom_swap( "nemo_crs" )
+      IF( ln_crs_top ) CALL iom_swap( "nemo_crs" )
+
+      CALL iom_put("ahtt_crs",ahtt_crs)
+      CALL iom_put("ahtu_crs",ahtu_crs)
+      CALL iom_put("ahtv_crs",ahtv_crs)
+      CALL iom_put("ahtw_crs",ahtw_crs)
+
  
       ! write the tracer concentrations in the file
@@ -40,5 +47,5 @@
          cltra = TRIM( ctrcnm(jn) )                  ! short title for tracer
          IF( lk_vvl ) THEN
-            CALL iom_put( cltra, trn(:,:,:,jn) * fse3t_n(:,:,:) )
+            CALL iom_put( TRIM(cltra), trn(:,:,:,jn) * fse3t_n(:,:,:) )
          ELSE
             CALL iom_put( TRIM(cltra), trn(:,:,:,jn) )
@@ -46,5 +53,5 @@
       END DO
       !
-      IF( ln_crs ) CALL iom_swap( "nemo" )
+      IF( ln_crs_top ) CALL iom_swap( "nemo" )
       !
    END SUBROUTINE trc_wri_my_trc
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 5601)
@@ -16,4 +16,5 @@
    USE oce_trc         ! ocean dynamics and active tracers
    USE trc             ! ocean passive tracers variables
+   USe domvvl
    USE trcnam_trp      ! passive tracers transport namelist variables
    USE traadv_cen2     ! 2nd order centered scheme (tra_adv_cen2   routine)
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trcbbl_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trcbbl_crs.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trcbbl_crs.F90	(revision 5601)
@@ -25,5 +25,5 @@
    USE trabbl_crs              ! 
    USE prtctl_trc          ! Print control for debbuging
-   USE trdmod_oce
+   USE trd_oce
    USE trdtra
 
@@ -95,5 +95,5 @@
         DO jn = 1, jptra
            ztrtrd(:,:,:,jn) = tra(:,:,:,jn) - ztrtrd(:,:,:,jn)
-           CALL trd_tra( kt, 'TRC', jn, jptra_trd_ldf, ztrtrd(:,:,:,jn) )
+           CALL trd_tra( kt, 'TRC', jn, jptra_ldf, ztrtrd(:,:,:,jn) )
         END DO
         CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrtrd ) ! temporary save of trends
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf_crs.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf_crs.F90	(revision 5601)
@@ -25,5 +25,5 @@
    USE traldf_iso_grif ! lateral mixing          (tra_ldf_iso_grif routine)
    USE traldf_lap_crs      ! lateral mixing            (tra_ldf_lap routine)
-   USE trdmod_oce
+   USE trd_oce
    USE trdtra
    USE prtctl_trc      ! Print control
@@ -83,5 +83,5 @@
                           CALL tra_ldf_iso_crs     ( kt, nittrc000, 'TRC', gtru ,gtrv , trb, tra, jptra, rn_ahtb_0 )
                        ENDIF
-      CASE ( 2 )   ;   CALL tra_ldf_bilap ( kt, nittrc000, 'TRC', gtru, gtrv, trb, tra, jptra            )  ! iso-level bilaplacian
+      CASE ( 2 )   ;   CALL tra_ldf_bilap ( kt, nittrc000, 'TRC', gtru, gtrv, gtrui, gtrvi, trb, tra, jptra            )  ! iso-level bilaplacian
       CASE ( 3 )   ;   CALL tra_ldf_bilapg( kt, nittrc000, 'TRC',             trb, tra, jptra            )  ! s-coord. horizontal bilaplacian
          !
@@ -97,5 +97,5 @@
          WRITE(charout, FMT="('ldf1 ')") ;  CALL prt_ctl_trc_info(charout)
                                             CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
-         CALL tra_ldf_bilap ( kt, nittrc000, 'TRC', gtru, gtrv, trb, tra, jptra            )
+         CALL tra_ldf_bilap ( kt, nittrc000, 'TRC', gtru, gtrv, gtrui, gtrvi, trb, tra, jptra            )
          WRITE(charout, FMT="('ldf2 ')") ;  CALL prt_ctl_trc_info(charout)
                                             CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
@@ -108,5 +108,5 @@
         DO jn = 1, jptra
            ztrtrd(:,:,:,jn) = tra(:,:,:,jn) - ztrtrd(:,:,:,jn)
-           CALL trd_tra( kt, 'TRC', jn, jptra_trd_ldf, ztrtrd(:,:,:,jn) )
+           CALL trd_tra( kt, 'TRC', jn, jptra_ldf, ztrtrd(:,:,:,jn) )
         END DO
         CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrtrd )
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 5601)
@@ -95,11 +95,22 @@
          IF( l_trdtrc ) ztrtrd(:,:,:) = tra(:,:,:,jn)  ! save trends
          !                                             ! add the trend to the general tracer trend
-         DO jj = 2, jpj
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zse3t = 1. / fse3t(ji,jj,1)
-               tra(ji,jj,1,jn) = tra(ji,jj,1,jn) + zsfx(ji,jj) *  zsrau * trn(ji,jj,1,jn) * zse3t
+         IF( lk_vvl ) THEN  ! online coupling with vvl
+
+            
+            DO jj = 2, jpj
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  zse3t = 1. / fse3t(ji,jj,1)
+                  tra(ji,jj,1,jn) = tra(ji,jj,1,jn) + zsfx(ji,jj) *  zsrau * trn(ji,jj,1,jn) * zse3t
+               END DO
             END DO
-         END DO
-         
+         ELSE
+            DO jj = 2, jpj
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  zse3t = 1. / fse3t(ji,jj,1)
+                  tra(ji,jj,1,jn) = tra(ji,jj,1,jn) + zsfx(ji,jj) *  zsrau * trn(ji,jj,1,jn) * zse3t
+               END DO
+            END DO
+         ENDIF
+
          IF( l_trdtrc ) THEN
             ztrtrd(:,:,:) = tra(:,:,:,jn) - ztrtrd(:,:,:)
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc_crs.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc_crs.F90	(revision 5601)
@@ -19,5 +19,5 @@
    USE trc             ! ocean  passive tracers variables
    USE prtctl_trc      ! Print control for debbuging
-   USE trdmod_oce
+   USE trd_oce
    USE trdtra
 !cbr   USE crs
@@ -101,5 +101,5 @@
          IF( l_trdtrc ) THEN
             ztrtrd(:,:,:) = tra(:,:,:,jn) - ztrtrd(:,:,:)
-            CALL trd_tra( kt, 'TRC', jn, jptra_trd_nsr, ztrtrd )
+            CALL trd_tra( kt, 'TRC', jn, jptra_nsr, ztrtrd )
          END IF
          !                                                       ! ===========
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 5601)
@@ -35,5 +35,6 @@
    USE zpshde_crs      ! partial step: hor. derivative       (zps_hde routine)
    USE dom_oce , ONLY : ln_crs
-   USe crs, ONLY : jpi_crs,jpj_crs,wn_crs !cbr
+   USE crs     , ONLY : jpi_crs,jpj_crs,wn_crs,ln_crs_top !cbr
+   USE ldfslp_crs
 
 #if defined key_agrif
@@ -75,25 +76,20 @@
       IF( .NOT. lk_c1d ) THEN
          !
-!         CALL test(kstp,1)
-!         IF( ln_crs ) THEN ;    CALL trc_sbc_crs( kstp )
-!         ELSE              ;    CALL trc_sbc( kstp )
-!         ENDIF
-!         CALL test(kstp,2)
-         IF( ln_crs ) THEN ;    CALL trc_bbl_crs( kstp )
+         IF( ln_crs_top ) THEN ;    CALL trc_sbc_crs( kstp )
+         ELSE              ;    CALL trc_sbc( kstp )
+         ENDIF
+         IF( ln_crs_top ) THEN ;    CALL trc_bbl_crs( kstp )
          ELSE              ;    CALL trc_bbl( kstp )
          ENDIF
          IF( ln_trcdmp )        CALL trc_dmp( kstp )            ! internal damping trends
-!         CALL test(kstp,3)
 
-         IF( ln_crs ) THEN ;    CALL trc_adv_crs( kstp )
+         IF( ln_crs_top ) THEN ;    CALL trc_adv_crs( kstp )
          ELSE              ;    CALL trc_adv( kstp )
          ENDIF
-!         CALL test(kstp,4)
 
          IF( ln_trcdmp_clo )    CALL trc_dmp_clo( kstp )        ! internal damping trends on closed seas only
-         IF( ln_crs ) THEN ;    CALL trc_ldf_crs( kstp )
+         IF( ln_crs_top ) THEN ;    CALL trc_ldf_crs( kstp )
          ELSE              ;    CALL trc_ldf( kstp )
          ENDIF
-!         CALL test(kstp,5)
          IF( .NOT. lk_offline .AND. lk_zdfkpp )    &
             &                   CALL trc_kpp( kstp )            ! KPP non-local tracer fluxes
@@ -101,10 +97,8 @@
          IF(.NOT. Agrif_Root()) CALL Agrif_Sponge_trc           ! tracers sponge
 #endif
-         IF( ln_crs ) THEN ;    CALL trc_zdf_crs( kstp )
+         IF( ln_crs_top ) THEN ;    CALL trc_zdf_crs( kstp )
          ELSE              ;    CALL trc_zdf( kstp )
          ENDIF
-!         CALL test(kstp,6)
                                 CALL trc_nxt( kstp )            ! tracer fields at next time step     
-!         CALL test(kstp,7)
          IF( ln_trcrad )        CALL trc_rad( kstp )            ! Correct artificial negative concentrations
 
@@ -112,8 +106,8 @@
       IF( .NOT. Agrif_Root())   CALL Agrif_Update_Trc( kstp )   ! Update tracer at AGRIF zoom boundaries : children only
 #endif
-         IF( ln_zps    )        CALL zps_hde( kstp, jptra, trn, gtru, gtrv )  ! Partial steps: now horizontal gradient of passive
+          ! Partial steps: now horizontal gradient of passive
          IF( ln_zps    )THEN
-         IF( ln_crs ) THEN ;    CALL zps_hde_crs( kstp, jptra, trn, gtru, gtrv )
-         ELSE              ;    CALL zps_hde( kstp, jptra, trn, gtru, gtrv )
+         IF( ln_crs_top ) THEN ;    CALL zps_hde_crs( kstp, jptra, trn, gtru, gtrv )
+         ELSE              ;    CALL zps_hde( kstp, jptra, trn, pgtu=gtru, pgtv=gtrv, sgtu=gtrui, sgtv=gtrvi )
          ENDIF
          ENDIF
@@ -136,5 +130,5 @@
    INTEGER,INTENT(IN) :: kt,i
    REAL(wp)::zmin,zmax
-   INTEGER :: ji,jj,jk
+   INTEGER :: ii,jj,kk
    zmin=MINVAL( trb(2:jpi-1,2:jpj-1,:,1),mask=(tmask(2:jpi-1,2:jpj-1,:)==1)) ; CALL mpp_min(zmin)
    zmax=MAXVAL( trb(2:jpi-1,2:jpj-1,:,1),mask=(tmask(2:jpi-1,2:jpj-1,:)==1)) ; CALL mpp_max(zmax)
@@ -146,21 +140,7 @@
    zmax=MAXVAL( tra(2:jpi-1,2:jpj-1,:,1),mask=(tmask(2:jpi-1,2:jpj-1,:)==1)) ; CALL mpp_max(zmax)
    IF(lwp)WRITE(numout,*)"trctrp a ",kt,i,zmin,zmax   
-   zmin=MINVAL( trn(2:jpi-1,2:jpj-1,1:jpk-1,1),mask=(tmask(2:jpi-1,2:jpj-1,1:jpk-1)==1)) ; CALL mpp_min(zmin)
-   zmax=MAXVAL( trn(2:jpi-1,2:jpj-1,1:jpk-1,1),mask=(tmask(2:jpi-1,2:jpj-1,1:jpk-1)==1)) ; CALL mpp_max(zmax)
-   IF(lwp)WRITE(numout,*)"trctrp n ",kt,i,zmin,zmax   
-   zmin=MINVAL( tra(2:jpi-1,2:jpj-1,1:jpk-1,1),mask=(tmask(2:jpi-1,2:jpj-1,1:jpk-1)==1)) ; CALL mpp_min(zmin)
-   zmax=MAXVAL( tra(2:jpi-1,2:jpj-1,1:jpk-1,1),mask=(tmask(2:jpi-1,2:jpj-1,1:jpk-1)==1)) ; CALL mpp_max(zmax)
-   IF(lwp)WRITE(numout,*)"trctrp a ",kt,i,zmin,zmax   
+   zmin=MINVAL( tra(2:jpi-1,2:jpj-1,30,1),mask=(tmask(2:jpi-1,2:jpj-1,30)==1)) ; CALL mpp_min(zmin)
+   zmax=MAXVAL( tra(2:jpi-1,2:jpj-1,30,1),mask=(tmask(2:jpi-1,2:jpj-1,30)==1)) ; CALL mpp_max(zmax)
 
-   IF(narea==267)WRITE(narea+5000,*)"tra(17,5,74,1) = ",kt,i,tra(17,5,74,1)
-
-   DO ji=1,jpi
-   DO jj=1,jpj
-   DO jk=1,jpk
-      IF( tra(ji,jj,jk,1) .NE.  tra(ji,jj,jk,1) )WRITE(narea+200,*)"BUG7 ",ji,jj,jk, tra(ji,jj,jk,1); CALL FLUSH(narea+200)
-   ENDDO
-   ENDDO
-   ENDDO
-   
    END SUBROUTINE test
 #else
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf_crs.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf_crs.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf_crs.F90	(revision 5601)
@@ -19,7 +19,8 @@
    USE trazdf_exp      ! vertical diffusion: explicit (tra_zdf_exp     routine)
    USE trazdf_imp_crs      ! vertical diffusion: implicit (tra_zdf_imp     routine)
-   USE trdmod_oce
+   USE trd_oce
    USE trdtra
    USE prtctl_trc      ! Print control
+   USE timing
 
    IMPLICIT NONE
@@ -72,14 +73,23 @@
       !
       IF( kt == nittrc000 )   CALL zdf_ctl          ! initialisation & control of options
-
-#if ! defined key_pisces
-      IF( neuler == 0 .AND. kt == nittrc000 ) THEN     ! at nittrc000
-         r2dt(:) =  rdttrc(:)           ! = rdttrc (restarting with Euler time stepping)
-      ELSEIF( kt <= nittrc000 + 1 ) THEN          ! at nittrc000 or nittrc000+1
-         r2dt(:) = 2. * rdttrc(:)       ! = 2 rdttrc (leapfrog)
+!cbr bug
+!#if ! defined key_pisces
+!      IF( neuler == 0 .AND. kt == nittrc000 ) THEN     ! at nittrc000
+!         r2dt(:) =  rdttrc(:)           ! = rdttrc (restarting with Euler time stepping)
+!      ELSEIF( kt <= nittrc000 + 1 ) THEN          ! at nittrc000 or nittrc000+1
+!         r2dt(:) = 2. * rdttrc(:)       ! = 2 rdttrc (leapfrog)
+!      ENDIF
+!#else
+!      r2dt(:) =  rdttrc(:)              ! = rdttrc (for PISCES use Euler time stepping)
+!#endif
+      IF( ln_top_euler) THEN
+         r2dt(:) =  rdttrc(:)              ! = rdttrc (use Euler time stepping)
+      ELSE
+         IF( neuler == 0 .AND. kt == nittrc000 ) THEN     ! at nittrc000
+            r2dt(:) =  rdttrc(:)           ! = rdttrc (restarting with Euler time stepping)
+         ELSEIF( kt <= nittrc000 + 1 ) THEN          ! at nittrc000 or nittrc000+1
+            r2dt(:) = 2. * rdttrc(:)       ! = 2 rdttrc (leapfrog)
+         ENDIF
       ENDIF
-#else
-      r2dt(:) =  rdttrc(:)              ! = rdttrc (for PISCES use Euler time stepping)
-#endif
 
       IF( l_trdtrc )  THEN
@@ -98,5 +108,4 @@
       CASE ( 0 ) ;  CALL tra_zdf_exp( kt, nittrc000, 'TRC', r2dt, nn_trczdf_exp, trb, tra, jptra )    !   explicit scheme 
       CASE ( 1 ) ;  CALL tra_zdf_imp_crs( kt, nittrc000, 'TRC', r2dt,                trb, tra, jptra )    !   implicit scheme          
-
       END SELECT
 
@@ -106,5 +115,5 @@
                ztrtrd(:,:,jk,jn) = ( ( tra(:,:,jk,jn) - trb(:,:,jk,jn) ) / r2dt(jk) ) - ztrtrd(:,:,jk,jn)
             END DO
-            CALL trd_tra( kt, 'TRC', jn, jptra_trd_zdf, ztrtrd(:,:,:,jn) )
+            CALL trd_tra( kt, 'TRC', jn, jptra_zdf, ztrtrd(:,:,:,jn) )
          END DO
          CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrtrd )
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 5601)
@@ -142,5 +142,7 @@
    USE oce , ONLY :   tsa     =>    tsa     !: 4D array contaning ( ta, sa )
    USE oce , ONLY :   rhop    =>    rhop    !: potential volumic mass (kg m-3) 
-   USE oce , ONLY :   rhd     =>    rhd     !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
+   USE crs , ONLY :   rhd     =>    rhd_crs    !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
+   USE crs , ONLY :   rn2b    =>    rb2_crs     !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
+   USE crs , ONLY :   rab_n   =>    rab_crs_n     !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
    USE crs , ONLY :   hdivn   =>    hdivn_crs   !: horizontal divergence (1/s)
    USE crs , ONLY :   hdivb   =>    hdivb_crs   !: horizontal divergence (1/s)
@@ -160,4 +162,10 @@
    USE crs , ONLY :   rnf        =>    rnf_crs        !: river runoff   [Kg/m2/s]
    USE crs , ONLY :   fr_i       =>    fr_i_crs       !: ice fraction (between 0 to 1)
+   USE trcnam_trp , ONLY :  aht0     =>   rn_ahtrc_0        !: horizontal eddy diffusivity for tracers (m2/s)
+   USE crs , ONLY :  ahtu     =>   ahtu_crs        !: lateral diffusivity coef. at u-points 
+   USE crs , ONLY :  ahtv     =>   ahtv_crs        !: lateral diffusivity coef. at v-points 
+   USE crs , ONLY :  ahtw     =>   ahtw_crs        !: lateral diffusivity coef. at w-points 
+   USE crs , ONLY :  ahtt     =>   ahtt_crs        !: lateral diffusivity coef. at t-points
+   USE ldftra_oce , ONLY :  rldf     =>   rldf
 
    USE crs , ONLY :   avt        =>   avt_crs         !: vert. diffusivity coef. at w-point for temp  
@@ -177,8 +185,8 @@
   !* direction of lateral diffusion *
 #if   defined key_ldfslp
-   USE ldfslp_crs , ONLY :   uslp       =>   uslp_crs         !: i-direction slope at u-, w-points
-   USE ldfslp_crs , ONLY :   vslp       =>   vslp_crs         !: j-direction slope at v-, w-points
-   USE ldfslp_crs , ONLY :   wslpi      =>   wslpi_crs        !: i-direction slope at u-, w-points
-   USE ldfslp_crs , ONLY :   wslpj      =>   wslpj_crs        !: j-direction slope at v-, w-points
+   USE crs , ONLY :   uslp       =>   uslp_crs         !: i-direction slope at u-, w-points
+   USE crs , ONLY :   vslp       =>   vslp_crs         !: j-direction slope at v-, w-points
+   USE crs , ONLY :   wslpi      =>   wslpi_crs        !: i-direction slope at u-, w-points
+   USE crs , ONLY :   wslpj      =>   wslpj_crs        !: j-direction slope at v-, w-points
 #endif
 
@@ -318,4 +326,6 @@
    USE oce , ONLY :   rhop    =>    rhop    !: potential volumic mass (kg m-3) 
    USE oce , ONLY :   rhd     =>    rhd     !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
+   USE oce , ONLY :   rab_n     =>    rab_n   !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
+   USE oce , ONLY :   rn2b    =>    rn2b    !: in situ density anomalie rhd=(rho-rau0)/rau0 (no units)
    USE oce , ONLY :   hdivn   =>    hdivn   !: horizontal divergence (1/s)
    USE oce , ONLY :   rotn    =>    rotn    !: relative vorticity    [s-1]
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcini.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 5601)
@@ -94,5 +94,5 @@
          cvol(:,:,jk) = e1e2t(:,:) * fse3t(:,:,jk) * tmask(:,:,jk)
       END DO
-      IF( lk_degrad ) cvol(:,:,:) = cvol(:,:,:) * facvol(:,:,:)      ! degrad option: reduction by facvol
+      !cbr IF( lk_degrad ) cvol(:,:,:) = cvol(:,:,:) * facvol(:,:,:)      ! degrad option: reduction by facvol
       !                                                              ! total volume of the ocean 
       areatot = glob_sum( cvol(:,:,:) )
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcstp.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcstp.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcstp.F90	(revision 5601)
@@ -66,5 +66,5 @@
             cvol(:,:,jk) = e1e2t(:,:) * fse3t(:,:,jk) * tmask(:,:,jk)
          END DO
-         IF( lk_degrad )  cvol(:,:,:) = cvol(:,:,:) * facvol(:,:,:)       ! degrad option: reduction by facvol
+         !cbr IF( lk_degrad )  cvol(:,:,:) = cvol(:,:,:) * facvol(:,:,:)       ! degrad option: reduction by facvol
          areatot         = glob_sum( cvol(:,:,:) )
       ENDIF
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcsub.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcsub.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/TOP_SRC/trcsub.F90	(revision 5601)
@@ -14,5 +14,5 @@
    USE prtctl_trc       ! Print control for debbuging
    USE iom, ONLY : jpnf90
-   USE in_out_manager, ONLY : jprstlib
+   USE iom_def, ONLY : jprstlib
    USE lbclnk
 !#if defined key_zdftke
@@ -112,5 +112,5 @@
           sshn_tm  (:,:)         = sshn_tm  (:,:)         + sshn  (:,:) 
           rnf_tm   (:,:)         = rnf_tm   (:,:)         + rnf   (:,:) 
-          h_rnf_tm (:,:)         = h_rnf_tm (:,:)         + h_rnf (:,:) 
+!cbr          h_rnf_tm (:,:)         = h_rnf_tm (:,:)         + h_rnf (:,:) 
           hmld_tm  (:,:)         = hmld_tm  (:,:)         + hmld  (:,:)
           fr_i_tm  (:,:)         = fr_i_tm  (:,:)         + fr_i  (:,:)
@@ -151,5 +151,5 @@
          ssha_temp  (:,:)        = ssha  (:,:)
          rnf_temp   (:,:)        = rnf   (:,:)
-         h_rnf_temp (:,:)        = h_rnf (:,:)
+!cbr         h_rnf_temp (:,:)        = h_rnf (:,:)
          hmld_temp  (:,:)        = hmld  (:,:)
          fr_i_temp  (:,:)        = fr_i  (:,:)
@@ -197,5 +197,5 @@
          sshn_tm  (:,:)          = sshn_tm    (:,:)       + sshn  (:,:) 
          rnf_tm   (:,:)          = rnf_tm     (:,:)       + rnf   (:,:) 
-         h_rnf_tm (:,:)          = h_rnf_tm   (:,:)       + h_rnf (:,:) 
+!cbr         h_rnf_tm (:,:)          = h_rnf_tm   (:,:)       + h_rnf (:,:) 
          hmld_tm  (:,:)          = hmld_tm    (:,:)       + hmld  (:,:)
          fr_i_tm  (:,:)          = fr_i_tm    (:,:)       + fr_i  (:,:)
@@ -208,5 +208,5 @@
          sshb     (:,:)          = sshb_hold  (:,:)
          rnf      (:,:)          = rnf_tm     (:,:) * r1_ndttrcp1 
-         h_rnf    (:,:)          = h_rnf_tm   (:,:) * r1_ndttrcp1 
+!cbr         h_rnf    (:,:)          = h_rnf_tm   (:,:) * r1_ndttrcp1 
          hmld     (:,:)          = hmld_tm    (:,:) * r1_ndttrcp1 
          !  variables that are initialized after averages
@@ -320,5 +320,5 @@
       sshn_tm  (:,:) = sshn  (:,:) 
       rnf_tm   (:,:) = rnf   (:,:) 
-      h_rnf_tm (:,:) = h_rnf (:,:) 
+!cbr      h_rnf_tm (:,:) = h_rnf (:,:) 
       hmld_tm  (:,:) = hmld  (:,:)
 
@@ -379,5 +379,5 @@
       ssha  (:,:)     =  ssha_temp  (:,:)
       rnf   (:,:)     =  rnf_temp   (:,:)
-      h_rnf (:,:)     =  h_rnf_temp (:,:)
+!cbr      h_rnf (:,:)     =  h_rnf_temp (:,:)
       !
       hmld  (:,:)     =  hmld_temp  (:,:)
@@ -428,5 +428,5 @@
       sshn_tm    (:,:) = sshn  (:,:) 
       rnf_tm     (:,:) = rnf   (:,:) 
-      h_rnf_tm   (:,:) = h_rnf (:,:) 
+!cbr      h_rnf_tm   (:,:) = h_rnf (:,:) 
       hmld_tm    (:,:) = hmld  (:,:)
       fr_i_tm    (:,:) = fr_i  (:,:)
